#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <deathrun_stats>
#include <xs>

#define PLUGIN "[DR Stats] Barney zamiast ramki"
#define VERSION "1.0"
#define AUTHOR "R3X"

new const gszFinish[] = "finish_button";
new const gszModel[] = "models/barney.mdl";

new const gszOkSounds[][] = {
	"barney/ba_another.wav",
	"barney/ba_endofline.wav",
	"barney/ba_gotone.wav",
	"barney/yougotit.wav"
};

new const gszFailSounds[][] = {
	"barney/ba_pissme.wav",
	"barney/ba_whatyou.wav",
	"barney/badfeeling.wav",
	"barney/dontguess.wav",
	"barney/nosir.wav",
	"barney/nope.wav"
};

new const Float:gfSize[2][3] = {
	{-15.0, -15.0, -5.0},
	{15.0, 15.0, 90.0}
};

decodeHashAngle(const Float:fOrigin[]){
	new hash = 0;
	for(new i=0;i<3;i++)
		hash += floatround(fOrigin[i]);
	hash %= 4;
	return hash;
}
encodeHashAngle(Float:fOrigin[], ang){
	new hash = decodeHashAngle(fOrigin);
	if(hash == ang) return;
	
	if(hash > ang)
		fOrigin[0] -= (hash-ang);
	else
		fOrigin[0] += (ang-hash);
	hash = decodeHashAngle(fOrigin);
}

getHashAngle1(Float:fAngle){
	if( 45 <= fAngle < 135)
		return 1;
	if( 135 <= fAngle < 225)
		return 2;
	if( 225 <= fAngle < 315)
		return 3;
		
	return 0;
}
getHashAngle2(const Float:fOrigin1[], const Float:fOrigin2[]){
	new Float:fAngles[3];
	xs_vec_sub(fOrigin2, fOrigin1, fAngles);
	
	vector_to_angle(fAngles, fAngles);
	return getHashAngle1(fAngles[1]);
	
}

new bool:gbFinished[33];
new gent;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	RegisterHam(Ham_Use, "func_button", "fwUse");
}
public plugin_precache(){
	precache_model(gszModel);
	
	for(new i=0;i<sizeof(gszOkSounds);i++)
		precache_sound(gszOkSounds[i]);
	for(new i=0;i<sizeof(gszFailSounds);i++)
		precache_sound(gszFailSounds[i]);
}

public fwFinishCreate(id, Float:fOrigin[3]){
	gent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_button"));
	set_pev(gent, pev_spawnflags, SF_BUTTON_DONTMOVE);
	set_pev(gent, pev_classname, gszFinish);
	new ang;
	new Float:fOrigin2[3];
	if(is_user_connected(id)){
		xs_vec_copy(fOrigin, fOrigin2);
		
		new iOrigin[3];
		get_user_origin(id, iOrigin, 3);
		IVecFVec(iOrigin, fOrigin);
		
		ang = getHashAngle2(fOrigin, fOrigin2);
		encodeHashAngle(fOrigin, ang);
	}else{
		ang = decodeHashAngle(fOrigin);
	}
	
	
	set_pev(gent, pev_origin, fOrigin);
	
	engfunc(EngFunc_SetModel, gent, gszModel);
	
	dllfunc(DLLFunc_Spawn, gent);
	set_pev(gent, pev_solid, SOLID_SLIDEBOX);
	set_pev(gent, pev_movetype, MOVETYPE_NONE);
	engfunc(EngFunc_SetSize, gent, gfSize[0], gfSize[1]);
	
	set_pev(gent, pev_sequence, 65);
	set_pev(gent, pev_framerate, 1.0);
	
	fOrigin2[0] = fOrigin2[2] = 0.0;
	fOrigin2[1] = 90.0*ang;
	set_pev(gent, pev_angles, fOrigin2);
	set_pev(gent, pev_controller_0, 127);
	
	
	return gent;
}
public client_putinserver(id){
	gbFinished[id] = true;
}
public fwPlayerStarted(id){
	gbFinished[id] = false;
}

public fwUse(ent, id){
	if(is_user_alive(id) && ent == gent){
		new rand;
		if(!gbFinished[id]){
			fwButtonUse(id);
			rand = random(sizeof(gszOkSounds));
			emit_sound(ent, CHAN_BODY, gszOkSounds[rand], VOL_NORM, ATTN_NORM, 0, PITCH_LOW);
		}
		else{
			rand = random(sizeof(gszFailSounds));
			emit_sound(ent, CHAN_BODY, gszFailSounds[rand], VOL_NORM, ATTN_NORM, 0, PITCH_LOW);
		}
	}
}

fwButtonUse(id){
	playerFinished(id);
	gbFinished[id] = true;
}

